package server;

import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;
import java.rmi.server.UnicastRemoteObject;

import transaction.ITransactionManager;
import transaction.TransactionManagerImpl;

public class TransactionManager {

	public static void main(String[] args) {
		try {            
            TransactionManagerImpl tm = new TransactionManagerImpl();
            ITransactionManager stub =
                (ITransactionManager) UnicastRemoteObject.exportObject(tm, 0);
            Registry registry = LocateRegistry.getRegistry();
            registry.rebind(ITransactionManager.RMI_TM_NAME, stub);
            System.out.println("TM bound");
        } catch (Exception e) {
            System.err.println("RM exception:");
            e.printStackTrace();
        }
	}
	
}
